/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "wGaussHex8.h"
#include "wGaussLine2.h"
#include <stdexcept>
#include <cmath>

using namespace tbox;

GaussHex8::GaussHex8(int n) : Gauss()
{
    GaussLine2 g(n);

    ngp = n * n * n;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            for (int k = 0; k < n; ++k)
            {
                p.push_back(Eigen::Vector3d(g.getP(i)(0), g.getP(j)(0), g.getP(k)(0)));
                w.push_back(g.getW(i) * g.getW(j) * g.getW(k));
            }
}
